\paragraph{Summary}
Python: using \verb|timeit| and \verb|cProfile|
\begin{itemize}
  \item Writing adjacency map to a file is costly.
  \item First implementation contained a conception mistake which made the complexity in $\bigO(n^2)$ (was corrected)
  \item For the same graph size: curveball fits but cooccurence do not fit into memory.
\end{itemize}

Julia is more efficient in terms of time and memory consumption (yds!)
\begin{itemize}
   \item Using inplace functions is usually faster and requires less momory allocations
   \item Profiling is not as user-friendly as in Python
\end{itemize}

\section{What does consume most time}
For the curveball (first implementation single core in python, assuming that the adjacency list fits in memory), most of the time is taken by writing the resulting adjacency list to a file (at each step). Saving in csv requires on average\footnote{Average over ten runs} 14 seconds for writing, 11 seconds for Pickle and JSON 19 seconds. Choosing one of such format does not seem to have a huge impact on the time to write the file.

\subsection{Netflix 20k good dataset}
$3.284.330$ edges.

\begin{footnotesize}
  \begin{verbatim}
~/Documents/SPPII/curveball/code/python/experiments/netflix/test_netflix.py
   57802512 function calls (57802506 primitive calls) in 199.216 seconds

   Ordered by: standard name

   ncalls  tottime  percall  cumtime  percall filename:lineno(function)
        1    0.090    0.090  199.216  199.216 <string>:1(<module>)
       11    0.000    0.000    0.000    0.000 _bootlocale.py:23(getpreferredencoding)
        5    0.000    0.000    0.000    0.000 _collections_abc.py:310(__subclasshook__)
        5    0.000    0.000    0.000    0.000 _weakrefset.py:16(__init__)
        5    0.000    0.000    0.000    0.000 _weakrefset.py:20(__enter__)
        5    0.000    0.000    0.000    0.000 _weakrefset.py:26(__exit__)
        4    0.000    0.000    0.000    0.000 _weakrefset.py:36(__init__)
        5    0.000    0.000    0.000    0.000 _weakrefset.py:52(_commit_removals)
        9    0.000    0.000    0.000    0.000 _weakrefset.py:58(__iter__)
   168366    0.069    0.000    0.069    0.000 _weakrefset.py:70(__contains__)
        5    0.000    0.000    0.000    0.000 _weakrefset.py:81(add)
   168360    0.100    0.000    0.170    0.000 abc.py:178(__instancecheck__)
      5/2    0.000    0.000    0.000    0.000 abc.py:194(__subclasscheck__)
       10    0.000    0.000    0.000    0.000 codecs.py:185(__init__)
        1    0.000    0.000    0.000    0.000 codecs.py:259(__init__)
        1    0.000    0.000    0.000    0.000 codecs.py:308(__init__)
     2630    0.003    0.000    0.014    0.000 codecs.py:318(decode)
    84180    1.436    0.000   28.718    0.000 core.py:20(trade_with_self_loop)
    84180    0.150    0.000    0.627    0.000 core.py:4(randomly_get_two_items)
    84180    5.995    0.000   27.282    0.000 core.py:58(exchange_neighbors)
       10    1.729    0.173  167.699   16.770 load_save_data.py:65(save_csv)
   168370   20.556    0.000   20.556    0.000 load_save_data.py:78(<listcomp>)
        1    0.335    0.335    1.210    1.210 load_save_data.py:81(read_csv)
    16837    0.680    0.000    0.680    0.000 load_save_data.py:95(<listcomp>)
       10    0.000    0.000    0.000    0.000 posixpath.py:145(dirname)
       20    0.000    0.000    0.000    0.000 posixpath.py:39(_get_sep)
       10    0.000    0.000    0.000    0.000 posixpath.py:71(join)
   168360    0.144    0.000    0.314    0.000 random.py:179(randrange)
 15950470   10.087    0.000   13.776    0.000 random.py:229(_randbelow)
    84180    7.310    0.000   21.279    0.000 random.py:289(sample)
        1    0.000    0.000    0.000    0.000 random.py:93(seed)
       10    0.464    0.046   29.821    2.982 run.py:4(step)
        1    0.396    0.396  199.126  199.126 test_netflix.py:9(main)
     2630    0.011    0.000    0.011    0.000 {built-in method _codecs.utf_8_decode}
       11    0.000    0.000    0.000    0.000 {built-in method _locale.nl_langinfo}
        1    0.000    0.000  199.216  199.216 {built-in method builtins.exec}
        5    0.000    0.000    0.000    0.000 {built-in method builtins.getattr}
   168381    0.104    0.000    0.274    0.000 {built-in method builtins.isinstance}
      7/4    0.000    0.000    0.000    0.000 {built-in method builtins.issubclass}
   420930    0.046    0.000    0.046    0.000 {built-in method builtins.len}
       11    0.001    0.000    0.001    0.000 {built-in method io.open}
    57170    0.020    0.000    0.020    0.000 {built-in method math.ceil}
    57170    0.025    0.000    0.025    0.000 {built-in method math.log}
        1    0.000    0.000    0.000    0.000 {function Random.seed at 0xb6fda614}
        3    0.000    0.000    0.000    0.000 {method '__subclasses__' of 'type' objects}
   332984    0.033    0.000    0.033    0.000 {method 'add' of 'set' objects}
 15950470    0.998    0.000    0.998    0.000 {method 'bit_length' of 'int' objects}
        1    0.000    0.000    0.000    0.000 {method 'disable' of '_lsprof.Profiler' objects}
       10    0.000    0.000    0.000    0.000 {method 'endswith' of 'str' objects}
   168380    0.324    0.000    0.324    0.000 {method 'format' of 'str' objects}
 23108423    2.691    0.000    2.691    0.000 {method 'getrandbits' of '_random.Random' objects}
       10    0.000    0.000    0.000    0.000 {method 'items' of 'dict' objects}
   168370    1.082    0.000    1.082    0.000 {method 'join' of 'str' objects}
       10    0.000    0.000    0.000    0.000 {method 'keys' of 'dict' objects}
   168370    0.149    0.000    0.149    0.000 {method 'pop' of 'list' objects}
        5    0.000    0.000    0.000    0.000 {method 'remove' of 'set' objects}
       10    0.000    0.000    0.000    0.000 {method 'rfind' of 'str' objects}
       10    0.000    0.000    0.000    0.000 {method 'rstrip' of 'str' objects}
    33674    0.174    0.000    0.174    0.000 {method 'split' of 'str' objects}
       10    0.000    0.000    0.000    0.000 {method 'startswith' of 'str' objects}
    16837    0.006    0.000    0.006    0.000 {method 'strip' of 'str' objects}
   168370  144.007    0.001  144.007    0.001 {method 'write' of '_io.TextIOWrapper' objects}

Process finished with exit code 0
  \end{verbatim}
\end{footnotesize}


\subsection{Book Crossing Dataset}
$1.149.780$ edges (right nodes are ISBN strings, not Integers as in the other datasets!).


Ten steps of the curveball takes around 130 seconds. Most of the runtime ($74.5\%$) is consumed by writing the adjacency matrix to file (10 seconds each).

\begin{footnotesize}
  \begin{verbatim}
~/Documents/SPPII/curveball/code/python/experiments/book_rating/test_bx.py
17560540 function calls (17529274 primitive calls) in 135.495 seconds

   Ordered by: standard name

   ncalls  tottime  percall  cumtime  percall filename:lineno(function)
        1    0.070    0.070  135.495  135.495 <string>:1(<module>)
   526410    1.765    0.000   11.629    0.000 core.py:20(trade_with_self_loop)
   526410    0.952    0.000    6.051    0.000 core.py:4(randomly_get_two_items)
   526410    2.740    0.000    9.864    0.000 core.py:58(exchange_neighbors)
       10    0.000    0.000    0.000    0.000 posixpath.py:120(dirname)
       10    0.000    0.000    0.000    0.000 posixpath.py:61(join)
        1    0.000    0.000    0.000    0.000 random.py:100(seed)
  1052820    1.230    0.000    1.334    0.000 random.py:175(randrange)
557659/526393    6.433    0.000    7.062    0.000 random.py:293(sample)
       10    1.301    0.130   19.078    1.908 run.py:4(step)
        1    0.325    0.325    0.448    0.448 test_bx.py:10(read_csv)
       10   11.037    1.104  115.557   11.556 test_bx.py:32(save_csv)
        1    0.342    0.342  135.425  135.425 test_bx.py:47(main)
        1    0.000    0.000    0.000    0.000 {function seed at 0xb7289aac}
    62644    0.041    0.000    0.041    0.000 {hasattr}
    31266    0.012    0.000    0.012    0.000 {isinstance}
  2663312    0.275    0.000    0.275    0.000 {len}
    99959    0.021    0.000    0.021    0.000 {math.ceil}
    99959    0.037    0.000    0.037    0.000 {math.log}
   104710    0.011    0.000    0.011    0.000 {method 'add' of 'set' objects}
        1    0.000    0.000    0.000    0.000 {method 'disable' of '_lsprof.Profiler' objects}
       10    0.000    0.000    0.000    0.000 {method 'endswith' of 'unicode' objects}
  1052830    1.286    0.000    1.286    0.000 {method 'format' of 'str' objects}
       10    1.424    0.142    1.424    0.142 {method 'items' of 'dict' objects}
  1052820    0.889    0.000    0.889    0.000 {method 'join' of 'str' objects}
       10    0.030    0.003    0.030    0.003 {method 'keys' of 'dict' objects}
  1052820    3.673    0.000    3.673    0.000 {method 'pop' of 'list' objects}
  6781727    0.556    0.000    0.556    0.000 {method 'random' of '_random.Random' objects}
       10    0.000    0.000    0.000    0.000 {method 'rfind' of 'unicode' objects}
       10    0.000    0.000    0.000    0.000 {method 'rstrip' of 'unicode' objects}
   210564    0.109    0.000    0.109    0.000 {method 'split' of 'str' objects}
       10    0.000    0.000    0.000    0.000 {method 'startswith' of 'str' objects}
   105282    0.014    0.000    0.014    0.000 {method 'strip' of 'str' objects}
  1052820  100.919    0.000  100.919    0.000 {method 'write' of 'file' objects}
       11    0.002    0.000    0.002    0.000 {open}
        1    0.000    0.000    0.000    0.000 {range}
  \end{verbatim}
\end{footnotesize}

\subsection{Amazon Dataset}
$1.234.877$ edges.
\begin{footnotesize}
  \begin{verbatim}
/home/julien/Documents/SPPII/curveball/code/python/experiments/amazon/test_amazon.py
         33992317 function calls in 182.251 seconds

       Ordered by: standard name

       ncalls  tottime  percall  cumtime  percall filename:lineno(function)
            1    0.081    0.081  182.251  182.251 <string>:1(<module>)
      1287850    2.618    0.000   17.139    0.000 core.py:20(trade_with_self_loop)
      1287850    2.446    0.000   61.298    0.000 core.py:4(randomly_get_two_items)
      1287850    4.268    0.000   14.521    0.000 core.py:58(exchange_neighbors)
           10   14.607    1.461   98.798    9.880 load_save_data.py:66(save_csv)
            1    1.055    1.055    1.194    1.194 load_save_data.py:82(read_csv)
           10    0.000    0.000    0.000    0.000 posixpath.py:120(dirname)
           10    0.000    0.000    0.000    0.000 posixpath.py:61(join)
            1    0.000    0.000    0.000    0.000 random.py:100(seed)
      2575700    3.173    0.000    3.456    0.000 random.py:175(randrange)
      1287850    9.407    0.000   10.098    0.000 random.py:293(sample)
           10    2.942    0.294   81.586    8.159 run.py:4(step)
            1    0.591    0.591  182.171  182.171 test_amazon.py:11(main)
            1    0.000    0.000    0.000    0.000 {function seed at 0xb7289aac}
      6439280    0.683    0.000    0.683    0.000 {len}
            1    0.000    0.000    0.000    0.000 {method 'disable' of '_lsprof.Profiler' objects}
           10    0.000    0.000    0.000    0.000 {method 'endswith' of 'unicode' objects}
      2575710    2.000    0.000    2.000    0.000 {method 'format' of 'str' objects}
           10    4.432    0.443    4.432    0.443 {method 'items' of 'dict' objects}
      2575700    1.056    0.000    1.056    0.000 {method 'join' of 'str' objects}
           10    0.036    0.004    0.036    0.004 {method 'keys' of 'dict' objects}
      2575700   55.158    0.000   55.158    0.000 {method 'pop' of 'list' objects}
      8750299    0.854    0.000    0.854    0.000 {method 'random' of '_random.Random' objects}
           10    0.000    0.000    0.000    0.000 {method 'rfind' of 'unicode' objects}
           10    0.000    0.000    0.000    0.000 {method 'rstrip' of 'unicode' objects}
       515140    0.109    0.000    0.109    0.000 {method 'split' of 'str' objects}
           10    0.000    0.000    0.000    0.000 {method 'startswith' of 'str' objects}
       257570    0.031    0.000    0.031    0.000 {method 'strip' of 'str' objects}
      2575700   76.702    0.000   76.702    0.000 {method 'write' of 'file' objects}
           11    0.001    0.000    0.001    0.000 {open}
            1    0.000    0.000    0.000    0.000 {range}
  \end{verbatim}
\end{footnotesize}



\subsection{Without writing the adjacency to a file}
\begin{itemize}
  \item the function \verb|pop| takes approximately half of the time. This is in \verb|randomly_choose_two_nodes|. This first implementation was $\bigO(n^2)$!
  \item replaced \verb|randomly_choose_two_nodes| by homemade function in $\bigO(n)$!
  \item using random.shuffle instead (slight improvement, couple of seconds)
\end{itemize}

\subsection{Impact of the size of the dataset}
\begin{figure}
  \includegraphics[scale=0.5]{img/time_vs_memory_amazon_dataset.png}
  \caption{Time consumption of 10 steps of the curveball algorithm vs size of the data sets (in number of nodes which is almost linear to number of bytes). Time consumption is in $\bigO(n^2)$!!}
  \label{fig.time.mem.amaz}
\end{figure}

\begin{figure}
  \includegraphics[scale=0.5]{img/time_vs_memory_amazon_dataset_new_pop_implementation.png}
  \caption{Time consumption of 10 steps of the curveball algorithm vs size of the data sets. New implementation (see issue 11 \texttt{https://git.cs.uni-kl.de/siebert/curveball/issues/11}). Time consumption is now linear.}
  \label{fig.time.mem.amaz}
  \begin{footnotesize}
    \begin{verbatim}
https://git.cs.uni-kl.de/siebert/curveball/commit/11c0eaab5eb4ef2e93bd1d69b29cccb5f180ef59
?view=parallel#d99586dadb54e179df32bd2356b789da055bd37a
    \end{verbatim}
  \end{footnotesize}
\end{figure}

\begin{figure}
  \includegraphics[scale=0.5]{img/time_vs_memory_amazon_dataset_comparing_implementations.png}
  \caption{Time consumption of 10 steps of the curveball algorithm vs size of the data sets. Orange is the new implementation  using random.shuffle (see issue 11 \texttt{https://git.cs.uni-kl.de/siebert/curveball/issues/11}). Time consumption is now linear.}
  \label{fig.time.mem.amaz}
  \begin{footnotesize}
    \begin{verbatim}
https://git.cs.uni-kl.de/siebert/curveball/commit/c1716d8bed1e6508b762c057547bd3b8d5b8ec58
    \end{verbatim}
  \end{footnotesize}
\end{figure}
